%PAKCS1.14 swi7 VARIABLESHARING

:-noSingletonWarnings.
:-noRedefineWarnings.
:-noDiscontiguousWarnings.

:-importModule('Maybe').
:-importModule('Prelude').
:-importModule('RedBlackTree').


:-curryModule('Set').

%%%%%%%%%%%% function types %%%%%%%%%%%%%%%%%%%
:-multifile functiontype/6.
:-dynamic functiontype/6.
functiontype('Set.empty',empty,0,'Set.empty',nofix,'TCons'('RedBlackTree.RedBlackTree',[_G1011181])).
functiontype('Set.null',null,0,'Set.null',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G1020087]),'TCons'('Prelude.Bool',[]))).
functiontype('Set.elem',elem,1,'Set.elem',nofix,'FuncType'(_G1028951,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G1028951]),'TCons'('Prelude.Bool',[])))).
functiontype('Set.insert',insert,0,'Set.insert',nofix,'FuncType'(_G1037905,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G1037905]),'TCons'('RedBlackTree.RedBlackTree',[_G1037905])))).
functiontype('Set.delete',delete,0,'Set.delete',nofix,'FuncType'(_G450842,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G450842]),'TCons'('RedBlackTree.RedBlackTree',[_G450842])))).
functiontype('Set.toList',toList,0,'Set.toList',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G459757]),'TCons'([],[_G459757]))).
functiontype('Set.fromList',fromList,0,'Set.fromList',nofix,'FuncType'('TCons'([],[_G468606]),'TCons'('RedBlackTree.RedBlackTree',[_G468606]))).
functiontype('Set.union',union,1,'Set.union',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G477596]),'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G477596]),'TCons'('RedBlackTree.RedBlackTree',[_G477596])))).
functiontype('Set.intersect',intersect,2,'Set.intersect',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G486682]),'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G486682]),'TCons'('RedBlackTree.RedBlackTree',[_G486682])))).
functiontype('Set.disjoint',disjoint,2,'Set.disjoint',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G495765]),'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G495765]),'TCons'('Prelude.Bool',[])))).

%%%%%%%%%%%% constructor types %%%%%%%%%%%%%%%%%%%
:-multifile constructortype/7.
:-dynamic constructortype/7.

%%%%%%%%%%%% function definitions %%%%%%%%%%%%%%%%%%%
'Set.empty'(_G516901,_G516902,_G516903):-freeze(_G516902,'blocked_Set.empty'(_G516901,_G516902,_G516903)).
'blocked_Set.empty'(_G517059,_G517062,_G517065):-hnf('RedBlackTree.empty'(partcall(2,'Prelude.==',[]),partcall(2,'Prelude.==',[]),partcall(2,'Prelude.<',[])),_G517059,_G517062,_G517065).

'Set.null'(_G517725,_G517726,_G517727):-freeze(_G517726,'blocked_Set.null'(_G517725,_G517726,_G517727)).
'blocked_Set.null'(_G517763,_G517766,_G517769):-hnf(partcall(1,'RedBlackTree.isEmpty',[]),_G517763,_G517766,_G517769).

'Set.elem'(_G518119,_G518120,_G518121,_G518122):-freeze(_G518121,'blocked_Set.elem'(_G518119,_G518120,_G518121,_G518122)).
'blocked_Set.elem'(_G518157,_G518284,_G518287,_G518290):-hnf('Prelude..'(partcall(1,'Maybe.isJust',[]),partcall(1,'RedBlackTree.lookup',[_G518157])),_G518284,_G518287,_G518290).

'Set.insert'(_G518932,_G518933,_G518934):-freeze(_G518933,'blocked_Set.insert'(_G518932,_G518933,_G518934)).
'blocked_Set.insert'(_G518970,_G518973,_G518976):-hnf(partcall(2,'RedBlackTree.update',[]),_G518970,_G518973,_G518976).

'Set.delete'(_G519365,_G519366,_G519367):-freeze(_G519366,'blocked_Set.delete'(_G519365,_G519366,_G519367)).
'blocked_Set.delete'(_G519403,_G519406,_G519409):-hnf(partcall(2,'RedBlackTree.delete',[]),_G519403,_G519406,_G519409).

'Set.toList'(_G519798,_G519799,_G519800):-freeze(_G519799,'blocked_Set.toList'(_G519798,_G519799,_G519800)).
'blocked_Set.toList'(_G519836,_G519839,_G519842):-hnf(partcall(1,'RedBlackTree.tree2list',[]),_G519836,_G519839,_G519842).

'Set.fromList'(_G520276,_G520277,_G520278):-freeze(_G520277,'blocked_Set.fromList'(_G520276,_G520277,_G520278)).
'blocked_Set.fromList'(_G520394,_G520397,_G520400):-hnf(partcall(1,'Prelude.foldr',['Set.empty','Set.insert']),_G520394,_G520397,_G520400).

'Set.union'(_G520914,_G520915,_G520916,_G520917):-freeze(_G520916,'blocked_Set.union'(_G520914,_G520915,_G520916,_G520917)).
'blocked_Set.union'(_G520952,_G521119,_G521122,_G521125):-hnf('Prelude..'(partcall(1,'Prelude.foldr',[_G520952,'Set.insert']),'Set.toList'),_G521119,_G521122,_G521125).

'Set.intersect'(_G521878,_G521879,_G521880,_G521881,_G521882):-freeze(_G521881,'blocked_Set.intersect'(_G521878,_G521879,_G521880,_G521881,_G521882)).
'blocked_Set.intersect'(_G521921,_G521930,_G522290,_G522293,_G522296):-hnf('Prelude.$'('Set.fromList','Prelude.$'(partcall(1,'Prelude.filter',[partcall(1,'Prelude.flip',[_G521930,partcall(1,'Set.elem',[])])]),'Prelude.apply'('Set.toList',_G521921))),_G522290,_G522293,_G522296).

'Set.disjoint'(_G523476,_G523477,_G523478,_G523479,_G523480):-freeze(_G523479,'blocked_Set.disjoint'(_G523476,_G523477,_G523478,_G523479,_G523480)).
'blocked_Set.disjoint'(_G523519,_G523528,_G523688,_G523691,_G523694):-hnf('Prelude.apply'('Set.null','Set.intersect'(_G523519,_G523528)),_G523688,_G523691,_G523694).

:-costCenters(['']).




%%%%% Number of shared variables: 0
